#!/usr/bin/python
from unicode_map import unicode_map
print("%d unicode code points"%len(unicode_map))

unicode_buckets = {}
for codept in unicode_map:
    bucket = codept >> 8
    ch = codept & 0xff

    if bucket not in unicode_buckets:
        unicode_buckets[bucket] = {}

    unicode_buckets[bucket][ch] = unicode_map[codept]

unicode_map = unicode_buckets
unicode_buckets = list(unicode_map.keys())
unicode_buckets.sort()

# this file will be loaded at $5000
fout = open("UNICODE.BIN", "wb")
fout.write(bytearray([ 0x00, 0x50 ]))

# write the page lookup table
page = 0x51
for i in range(256):
    if i in unicode_map:
        p = page
        page += 2
    else:
        p = 0
    fout.write(bytearray([p]))

# write 512 bytes of screen codes for each bucket
for bucket in unicode_buckets:
    bucket = unicode_map[bucket]
    for i in range(256):
        if i in bucket:
            ch = bucket[i]
        else:
            ch = 0
        fout.write(bytearray([ ch&0xff, ch>>8 ]))

fout.close()
