; start of screen code lookup tables. loaded from UNICODE.PRG
unicode_page_table=$5000

; returns the 16-bit screen code for a given 16-bit unicode code point.
; if there is no glyph available, scr code is $0000
; ( Codept ) -- ( Scrcode )
unicode_lookup_screen_code:
    ; lookup unicode page in page table
    lda #>unicode_page_table
    sta r0_hi
    stz r0_lo                       ; r0 = unicode_page_table
    ldy 1,x                         ; .Y = Codept hi
    lda (r0),y
    ; if .A is zero then there are no available glyphs from this page
    bne _page_found
        stz 0,x
        stz 1,x                     ; ( Zero )
        rts
_page_found:
    ; if the page is available, then .A has location of relevant screen
    ; code table
    sta r0_hi                       ; r0 is pointer to glyph table
    lda 0,x                         ; .A = Codept lo
    asl     ; table contains 16-bit entries
    bcc +
        inc r0_hi   ; page turn
+   tay
    lda (r0),y                      ; Scrcode lo
    sta 0,x
    iny
    lda (r0),y                      ; Scrcode hi
    sta 1,x                         ; ( Scrcode )
    rts
