; zero-page variables
UTF8_PARSE_CODEPT=$f0
UTF8_PARSE_CHLEN=$f2

; inserts a single byte from .A into the utf-8 parser.
; when the routine returns, if Zero flag is set then a character has been
; completed and utf8_parse_codept contains the 16-bit unicode code point.
;
; this function does not use the data stack but preserves the .X register
utf8_parse_byte:
    ora #0
    bmi _multibyte
    ; single byte character
    sta utf8_parse_codept           ; Codept lo
    stz utf8_parse_codept+1         ; Codept hi
    stz utf8_parse_chlen            ; chlen
    lda #0
    rts
_multibyte:
    asl     ; hi bit is known to be 1
    asl     ; if this next bit is 0 then it's a continuation byte
    bcc _continuation
    ; begin a new multi-byte character
    stz utf8_parse_codept+1         ; Codept hi
    ldy #1
    sty utf8_parse_chlen
    asl
    bcc _two_bytes
    asl
    bcc _three_bytes
_four_bytes:
    inc utf8_parse_chlen
_three_bytes:
    inc utf8_parse_chlen
    lsr
_two_bytes:
    lsr
    lsr
    lsr
    sta utf8_parse_codept           ; Codept lo
    lda utf8_parse_chlen
    rts
_continuation:
    ; continue a multi-byte character
    ; shift the six bits left in the accumulator into Codept
    .rept 6
        asl
        rol utf8_parse_codept       ; Codept lo
        rol utf8_parse_codept+1     ; Codept hi
    .next
    dec utf8_parse_chlen            ; chlen
    lda utf8_parse_chlen
    rts
